####################################################
# Blah Software Code      |    Software Version: 3 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2003 e-blah!                  #
# All Rights Reserved                              #
####################################################

require("$language/SourceCodeMod.lng");

%Actions = ( # Action Numbers (speeds up process)
	1 => 'After',
	2 => 'Replace',
	3 => 'Before'
);

sub SourceMod {
	&is_admin;
	if($URL{'p'} eq 'install') { &InstallMod; }
	elsif($URL{'p'} eq 'create') { &CreateMod; }
	elsif($URL{'p'} eq 'browser') { &Browser; }

	$title = $sourcecode[1];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="700" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b>&#149; $sourcecode[2]</b></font></td>
 </tr>
EOT
	@bgcolor = ($color{'win2'},$color{'win'});
	opendir(DIR,"$root/Mods/");
	@themes = readdir(DIR);
	closedir(DIR);
	foreach(@themes) {
		if($_ =~ m/(.*)(.v1m)/) {
			$color = $bgcolor[$count % 2];
			if($modlist) { $hr = qq~<hr size="1" color="$color{'border'}">~; };
			$install = -e("$root/Mods/$1.installed") ? $sourcecode[3] : $sourcecode[4];
			$about = '';
			$author = '';
			$msite = '';
			$mver = '';
			$bver = '';
			require("$root/Mods/$1.v1m");
			$name = $1;
			$name2 = $name;
			$name =~ s/ /\+/gsi;
			$explain = '';
			if($about) { $explain = qq~<tr><td><font size="1"><b>$sourcecode[5]:</b></font></td><td><font size="1">$about</font></td></tr>~; }
			if($author) { $explain .= qq~<tr><td><font size="1"><b>$sourcecode[6]:</b></font></td><td><font size="1">$author</font></td></tr>~; }
			if($msite) { $explain .= qq~<tr><td><font size="1"><b>$sourcecode[7]:</b></font></td><td><font size="1"><a href="$msite">$msite</a></font></td></tr>~; }
			if($mver) { $explain .= qq~<tr><td><font size="1"><b>$sourcecode[8]:</b></font></td><td><font size="1">$mver</font></td></tr>~; }
			if($bver) { $explain .= qq~<tr><td><font size="1"><b>$sourcecode[9]:</b></font></td><td><font size="1">$bver</font></td></tr>~; }
			if(!$explain) { $explain = qq~<tr><td><font size="1">$sourcecode[80]</font></td></tr>~; }
			$name2 = $mname ? $mname : $name2;
			$modlist .= <<"EOT";
 <tr>
  <td bgcolor="$color">
   <table width="100%"><tr>
    <td>$hr<font size="2"><b>$name2</b></font><font size="1"><br>&nbsp; <b><a href="$scripturl,v=admin,a=sourcemod,p=install,m=$name">$install</a></b> &#149; <a href="$scripturl,v=admin,a=sourcemod,p=install,m=$name,t=1">$sourcecode[11] $install</a> &#149; <a href="$scripturl,v=admin,a=sourcemod,p=create,m=$name">$sourcecode[10]</a><hr size="1" color="$color{'border'}"></font></td>
   </tr><tr>
    <td><table>$explain</table></font></td>
   </tr></table>
  </td>
 </tr>
EOT
			++$count;
		}
	}
	if(!$modlist) { ++$count; $modlist = qq~<tr><td bgcolor="$color{'win2'}"><i>$sourcecode[80]</i></td></tr>~; }
	$color = $bgcolor[$count % 2];
	$color2 = $bgcolor[($count+1) % 2];
	print <<"EOT";
 <tr>
  <td bgcolor="$color{'win'}"><font size="1">$sourcecode[12]</font></td>
 </tr>
$modlist
 <tr>
  <td bgcolor="$color"><font size="1"><b>-&#187; <a href="$scripturl,v=admin,a=sourcemod,p=create">$sourcecode[13]</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color2"><font size="1"><b>$sourcecode[14]:</b> Version 1<br><b>$sourcecode[15]:</b> 3 Final Beta</font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub InstallMod {
	&is_admin;
	$URL{'m'} =~ s/\+/ /gsi;
	if(!-e("$root/Mods/$URL{'m'}.v1m")) { &error("$sourcecode[16] $URL{'m'}.v1m"); }
	require("$root/Mods/$URL{'m'}.v1m");

	$title = $sourcecode[17];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="700" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="2">
   <table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" align="center" width="650">
    <tr>
     <td bgcolor="$color{'titlebg'}"><font size="1"><b>&#187; $sourcecode[18]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}"><font size="1">
EOT
	foreach(@files) {
		($file,$keys) = split(/\|/,$_);
		++$keys;
		$filemod = $file;
		$filemod =~ s/Code\//$code\//gsi;
		$filemod =~ s/Root\//$root\//gsi;
		if($i) { $br = "<br>"; }
		fopen(FILE,"$filemod");
		@modify = <FILE>;
		fclose(FILE);
		chomp @modify;
		$ferror = '';
		if($modify[0] eq '') { $ferror = qq~<font color="red" size="1"> <b>:: $sourcecode[19]</b></font>~; $error = 1; $e{$filemod} = 1; }
		print qq~$br<font size="2"><b>$sourcecode[20]:</b> $file$ferror</font><hr size='1' color='$color{'border'}'>~;
		$onestring = '';
		foreach(@modify) { $onestring .= "$_\\n"; }
		for($i = 1; $i < $keys; $i++) {
			$action = '';
			for($z = 0; $z < 4; $z++) {
				if($change{$file,$Actions{$z}}->[$i]) { $action = $Actions{$z}; }
			}
			if($action eq '') { $action = "$sourcecode[21]"; }

			if(!-e("$root/Mods/$URL{'m'}.installed")) {
				$test = Format($change{$file,'s'}->[$i]);
				$test =~ s/\t/&nbsp; /g;
				print "<b>Source Code:</b><blockquote>$test</blockquote>";
				$test = Format($change{$file,$action}->[$i]);
				$test =~ s/\t/&nbsp; /g;
				print "<b>$action:</b><blockquote>$test</blockquote>";
				$find = $change{$file,'s'}->[$i];
				$replace = $change{$file,$action}->[$i];
				$install = 1;
			} else {
				$test = Format($change{$file,$action}->[$i]);
				$test =~ s/\t/&nbsp; /g;
				print "<b>Source Code:</b><blockquote>$test</blockquote>";
				$test = Format($change{$file,'s'}->[$i]);
				$test =~ s/\t/&nbsp; /g;
				print "<b>$action:</b><blockquote>$test</blockquote>";
				$find = $change{$file,$action}->[$i];
				$replace = $change{$file,'s'}->[$i];
			}
			$find =~ s~\n~\\n~gsi;
			$find =~ s/\cM//g;
			$replace =~ s~\n~\\n~gsi;
			$replace =~ s/\cM//g;
			$ok = 0;
			if($action eq 'Replace') {
				if($onestring =~ s~\Q$find\E~$replace~g) { print "<b>--&#187; $sourcecode[22]</b><br>"; }
					else { print qq~<b><font color="red">--&#187; $sourcecode[23]</font></b><br>~; $error = 1; $e{$filemod} = 1; }
			}
			elsif($action eq 'After' && $install) {
				if($onestring =~ s~\Q$find\E~$find\n$replace~g) { print "<b>--&#187; $sourcecode[22]</b><br>"; }
					else { print qq~<b><font color="red">--&#187; $sourcecode[23]</font></b><br>~; $error = 1; $e{$filemod} = 1; }
			}
			elsif($action eq 'Before' && $install) {
				if($onestring =~ s~\Q$find\E~$replace\n$find~g) { print "<b>--&#187; $sourcecode[22]</b><br>"; }
					else { print qq~<b><font color="red">--&#187; $sourcecode[23]</font></b><br>~; $error = 1; }
			}
			elsif($action eq 'Before' && !$install) {
				if($onestring =~ s~\Q$find\n$replace\E~$replace~g) { print "<b>--&#187; $sourcecode[22]</b><br>"; }
					else { print qq~<b><font color="red">--&#187; $sourcecode[23]</font></b><br>~; $error = 1; }
			}
			elsif($action eq 'After' && !$install) {
				if($onestring =~ s~\Q$replace\n$find\E~$replace~g) { print "<b>--&#187; $sourcecode[22]</b><br>"; }
					else { print qq~<b><font color="red">--&#187; $sourcecode[23]</font></b><br>~; $error = 1; }
			} else { print qq~<b><font color="red">--&#187; $sourcecode[24] '$file'!</font></b><br>~; $error = 1; $e{$filemod} = 1; }
			$modify{$filemod} = $onestring; # This is a protection against errors
		}
	}
	if($URL{'s'}) { $error = 0; } # Turn off error checks and install
	print <<"EOT";
    <tr>
     <td bgcolor="$color{'titlebg'}"><font size="1"><b>&#187; $sourcecode[25]</b></font></td>
    </tr><tr>
     <td bgcolor="$color{'win2'}"><font size="1">
EOT
	if($error && $URL{'t'}) { print qq~$sourcecode[26]<hr color="$color{'border'}" size="1">~; }
	elsif($error) { print qq~<img src="$images/warning_sm.gif"> $sourcecode[27] <a href="$scripturl,v=admin,a=sourcemod,p=install,m=Test,s=1">$sourcecode[28]</a>, $sourcecode[29]<hr color="$color{'border'}" size="1">~; }
	elsif($URL{'t'}) { print qq~$sourcecode[30] <a href="$scripturl,v=admin,a=sourcemod,p=install,m=$URL{'m'},s=1">$sourcecode[31]</a>.<hr color="$color{'border'}" size="1">~; $error = 1; }
	while(($filename,$write) = each(%modify)) {
		if($error) { last; }
		$postinstalle = '';
		$time = time;
		rename($filename,"$filename.bkup.$time");
		$write =~ s/\\n/\n/gsi;
		fopen(FILE,">$filename");
		print FILE $write;
		fclose(FILE);
		if($e{$filename}) { $postinstalle = qq~ :: <font color="red">$sourcecode[32]</font>~; }
		print qq~<b>$sourcecode[33]:</b> $filename$postinstalle<br>~;
		delete($modify{$file});
	}
	if($error) { print qq~<b>Files Modified:</b> <i>None</i>~; }

	if(-e("$root/Mods/$URL{'m'}.installed") && !$error) { unlink("$root/Mods/$URL{'m'}.installed"); }
	elsif(!$error) {
		fopen(FILE,">$root/Mods/$URL{'m'}.installed");
		fclose(FILE);
	}
	print <<"EOT";
     </font></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><a href="$scripturl,v=admin,a=sourcemod"><b>$sourcecode[34]</b></a></font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub CreateMod {
	&is_admin;
	if($URL{'m'} eq '') {
		$title = $sourcecode[13];
		&header;
		print <<"EOT";
<SCRIPT LANGUAGE="JavaScript">
<!-- Start
function Submit() {
 document.sform.submit.disabled = true;
}
// End -->
</script>
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="400" align="center">
 <tr><form action="$scripturl,v=admin,a=sourcemod,p=create,m=new" method="post" name="sform" onSubmit="Submit()">
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$sourcecode[35]</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}">
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr>
     <td align="right"><font size="2"><b>$sourcecode[36]:</b></font></td>
     <td><input type="text" name="name" value=""></td>
    </tr>
   </table></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><input type="submit" value=" $sourcecode[37] " name="submit"></td>
 <form></tr>
</table>
EOT
		&footer;
		exit;
	} elsif($URL{'m'} eq 'new') {
		$FORM{'name'} =~ s/[#%+,\\\/:?"<>'|@^\$\&~'\]\[\;{}!`=-]//gsi;
		$FORM{'name'} =~ s/ //gsi;
		if($FORM{'name'} eq '') { &error($sourcecode[39]); }
		if(-e("$root/Mods/$FORM{'name'}.v1m")) { &error($sourcecode[38]); }
		fopen(FILE,">$root/Mods/$FORM{'name'}.v1m");
		print FILE "1;";
		fclose(FILE);
		redirect("$scripturl,v=admin,a=sourcemod,p=create,m=$FORM{'name'}");
	}
	if(!-e("$root/Mods/$URL{'m'}.v1m")) { &error($sourcecode[40]); }
	if($FORM{'spec'}) { $URL{'f'} = "$FORM{'folder'}/$FORM{'spec'}"; }
	if($URL{'s'} || ($URL{'d'} && $URL{'f'} && $FORM{'action'} && $FORM{'searchfor'})) { &Save; }
	$modifing = $URL{'f'} ? $URL{'f'} : "<i>$sourcecode[41]</i>";
	$title = $sourcecode[42];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="750" align="center">
 <tr><form action="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=$URL{'d'},n=$URL{'n'}" method="post" name="save">
  <td bgcolor="$color{'titlebg'}" colspan="2"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="2"><font size="1">$sourcecode[43]</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="2"><font size="2"><b><img src="$images/open_thread.gif"> $sourcecode[44]:</b> "$modifing" <b>$sourcecode[45]:</b> "$URL{'m'}"</font><br><font size="1">&nbsp; &nbsp; &nbsp;<b>- <a href="$scripturl,v=admin,a=sourcemod,p=browser,m=$URL{'m'}">$sourcecode[46]</a></b></font></td>
 </tr>
EOT
	require("$root/Mods/$URL{'m'}.v1m");
	foreach(@files) {
		($file,$keys) = split(/\|/,$_);
		$filemod .= qq~<b><a href="$scripturl,v=admin,a=sourcemod,p=create,f=$file,m=$URL{'m'}">$file</a></b> ($keys $sourcecode[47])<br>~;
		++$keys;
		if($file ne $URL{'f'}) { next; }
		for($i = 1; $i < $keys; $i++) {
			for($z = 0; $z < 4; $z++) {
				if($change{$file,$Actions{$z}}->[$i]) { $action = $Actions{$z}; }
			}
			$acts .= qq~<b><a href="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=$action,n=$i">$action</a></b> -&#155; $sourcecode[48] $i<br>~;
			if($URL{'n'} == $i) {
				$search = $change{$file,'s'}->[$i];
				$changes = $change{$file,$action}->[$i];
				$delete = qq~ <input type="submit" value=" $sourcecode[49] " name="delete">~;
			}
		}
	}
	if(!$filemod) { $filemod = $sourcecode[50]; }
	if($URL{'d'} && $URL{'f'}) {
		if($URL{'d'} eq 'after') { $action = $sourcecode[51]; }
		elsif($URL{'d'} eq 'before') { $action = $sourcecode[52]; }
			else { $action = $sourcecode[53]; }
		$preform = <<"EOT";
$sourcecode[54]
<textarea name="searchfor" wrap="virtual" rows="5" cols="112">$search</textarea><br><br>

$action
<textarea name="action" wrap="virtual" rows="5" cols="112">$changes</textarea><br><br>
<input type="submit" value=" Save Action " name="submit">$delete<br>
<br><font size="1"><b>$sourcecode[55]:</b> (\\t) $sourcecode[56]</font>
EOT
	} else { $preform = $sourcecode[57]; }

	$version =~ s/(.+?) \((.+?)\)//gsi;
	$version = $1;
	$bver = $bver ? $bver : $version;
	$mname = $mname ? $mname : $URL{'m'};
	$about = Unformat($about);

	if(!$acts) { $acts = $sourcecode[58]; }
	print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b>&#149; $sourcecode[59]</b></font></td>
  <td bgcolor="$color{'catbg'}" width="20%"><font size="2"><b>&#149; $sourcecode[60]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" valign="top"><font size="1">$preform</font></td>
  <td bgcolor="$color{'win'}" width="20%" valign="top"><font size="1">$acts</font></td>
 </form></tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="1"><b>&#149; $sourcecode[61]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="2"><font size="1"><b>- <a href="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=After">$sourcecode[63]</a><br>- <a href="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=Before">$sourcecode[62]</a><br>- <a href="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=Replace">$sourcecode[64]</a></b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="1"><b>&#149; $sourcecode[65]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="2"><font size="1">$filemod</font></td>
 </tr><tr><form action="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'},d=$URL{'d'},n=$URL{'n'},s=1" method="post" name="save">
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="1"><b>&#149; $sourcecode[66]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" colspan="2">
   <table cellpadding="3" cellspacing="0">
    <tr>
     <td align="right"><font size="1"><b>$sourcecode[67]:</b></font></td>
     <td><input type="text" name="title" value="$mname" size="50"></td>
    </tr><tr>
     <td align="right"><font size="1"><b>$sourcecode[68]:</b></font></td>
     <td><input type="text" name="author" value="$author" size="40"></td>
    </tr><tr>
     <td align="right"><font size="1"><b>$sourcecode[69]:</b></font></td>
     <td><input type="text" name="msite" value="$msite" size="35"></td>
    </tr><tr>
     <td align="right"><font size="1"><b>$sourcecode[70]:</b></font></td>
     <td><input type="text" name="mver" value="$mver" size="13"></td>
    </tr><tr>
     <td align="right"><font size="1"><b>$sourcecode[71]:</b></font></td>
     <td><input type="text" name="bver" value="$bver" size="13"></td>
    </tr><tr>
     <td align="right" valign="top"><font size="1"><b>$sourcecode[72]:</b></font></td>
     <td><textarea name="about" wrap="virtual" rows="3" cols="50">$about</textarea></td>
    </tr><tr>
     <td colspan="2"><input type="submit" name="submit" value=" $sourcecode[73] "></td>
    </tr>
   </table>
  </td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}

sub QuickFormat {
	($format) = $_[0];
	$format =~ s/\(\\t\)/\t/gsi;
	$format =~ s/\*/\\\*/gsi;
	return($format);
}

sub Save {
	&is_admin;
	$key = 0;
	require("$root/Mods/$URL{'m'}.v1m");

	$sfor = QuickFormat($FORM{'searchfor'});
	$act = QuickFormat($FORM{'action'});

	fopen(FILE,">$root/Mods/$URL{'m'}.v1m");
	foreach(@files) {
		($file,$keys) = split(/\|/,$_);
		if($file eq $URL{'f'} && !$URL{'s'}) {
			$key = $keys;
			if(!$URL{'n'} && !$FORM{'delete'}) { ++$key; }
			elsif($URL{'n'} && $FORM{'delete'}) { --$key; }
			if($key == 0) { next; }
			$all .= qq~"$file|$key",~;
		} else { $all .= qq~"$file|$keys",~; }

		++$keys;
		$sds = 1;
		for($i = 1; $i < $keys; $i++) {
			$action = '';
			for($z = 0; $z < 4; $z++) {
				if($change{$file,$Actions{$z}}->[$i]) { $action = $Actions{$z}; }
			}

			if($action) {
				if($file eq $URL{'f'} && $i == $URL{'n'} && !$URL{'s'}) {
					$change{$file,'s'}->[$i] = $sfor;
					$change{$file,$action}->[$i] = $act;
				}
				if($FORM{'delete'} && $URL{'n'} == $i && $URL{'f'} eq $file) { next; }
				$topmods .= "# $sds\n\$change{'$file','s'}->[$sds] = qq*$change{$file,'s'}->[$i]*;\n";
				$topmods .= "\$change{'$file','$action'}->[$sds] = qq*$change{$file,$action}->[$i]*;\n";
				++$sds;
			}
		}
	}
	if(!$key && !$URL{'n'} && !$URL{'s'}) { ++$key; $all .= qq~"$URL{'f'}|$key",~; }
	$all =~ s/,\Z//gsi;
	print FILE "\@files = ($all);\n$topmods";
	if(!$URL{'n'} && !$FORM{'delete'} && !$URL{'s'}) {
		print FILE "# $key\n\$change{'$URL{f}','s'}->[$key] = qq*$sfor*;\n";
		print FILE "\$change{'$URL{f}','$URL{d}'}->[$key] = qq*$act*;\n";
	}
	if($URL{'s'}) {
		while(($in,$out) = each(%FORM)) {
			$out = Format($out);
			$out = QuickFormat($out);
			$FORM{$in} = $out;
		}
		if($FORM{'title'} ne $URL{'m'}) { print FILE qq~\$mname = '$FORM{title}';\n~; }
		if($FORM{'author'}) { print FILE qq~\$author = '$FORM{author}';\n~; }
		if($FORM{'about'}) { print FILE qq~\$about = '$FORM{about}';\n~; }
		if($FORM{'mver'}) { print FILE qq~\$mver = '$FORM{mver}';\n~; }
		if($FORM{'bver'}) { print FILE qq~\$bver = '$FORM{bver}';\n~; }
		if($FORM{'msite'}) { print FILE qq~\$msite = '$FORM{msite}';\n~; }
	} else {
		$mname = QuickFormat($mname);
		$author = QuickFormat($author);
		$about = QuickFormat($about);
		$mver = QuickFormat($mver);
		$bver = QuickFormat($bver);
		$msite = QuickFormat($msite);
		print FILE qq~\$mname = '$mname';\n\$author = '$author';\n\$about = '$about';\n\$mver = '$mver';\n\$bver = '$bver';\n\$msite = '$msite';\n~;
	}
	print FILE "1;";
	fclose(FILE);

	&redirect("$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'},f=$URL{'f'}");
}

sub Browser {
	&is_admin;
	opendir(DIR,"$code/");
	@directory = readdir(DIR);
	closedir(DIR);
	foreach(@directory) {
		if($_ eq '.' || $_ eq '..') { next; }
		$codedir .= qq~<a href="$scripturl,v=admin,a=sourcemod,p=create,f=Code/$_,m=$URL{'m'}">$_</a><br>~;
	}
	opendir(DIR,"$root/");
	@directory = readdir(DIR);
	closedir(DIR);
	foreach(@directory) {
		if($_ eq '.' || $_ eq '..' || $_ eq 'Boards' || $_ eq 'Code' || $_ eq 'Members' || $_ eq 'Messages' || $_ eq 'Prefs' || $_ eq 'Themes' || $_ eq 'Mods') { next; }
		$rootdir .= qq~<a href="$scripturl,v=admin,a=sourcemod,p=create,f=Root/$_,m=$URL{'m'}">$_</a><br>~;
	}
	$title = $sourcecode[74];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="400" align="center">
 <tr><form action="$scripturl,v=admin,a=sourcemod,p=create,m=$URL{'m'}" method="post" name="save">
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b>&#149; $sourcecode[75]: Root</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$rootdir</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b>&#149; $sourcecode[75]: Code</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">$codedir</font></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b>&#149; $sourcecode[76]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}">
   <table cellpadding="4" cellspacing="0">
    <tr>
     <td align="right"><font size="2"><b>$sourcecode[77]:</b></font></td>
     <td><select name="folder">
      <option value="Root">Root</option>
      <option value="Code">Code</option>
     </select></td>
    </tr><tr>
     <td align="right"><font size="2"><b>$sourcecode[78]:</b></font></td>
     <td><input type="text" name="spec" value=""></td>
    </tr><tr>
     <td align="right" colspan="2"><input type="submit" value=" $sourcecode[79] " name="dir"></td>
    </tr>
   </table>
  </td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}
1;