####################################################
# Blah Software Code      |    Software Version: 3 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2003 e-blah!                  #
# All Rights Reserved                              #
####################################################

require("$language/Load.lng");

sub is_admin {
	if($settings[4] ne 'Administrator') { &error("$ltxt[1]-admin-",1); }
}

sub is_mod {
	if($settings[4] ne 'Administrator' && !$ismod) { &error($ltxt[2],1); }
}

sub is_member {
	if($vradmin == 1) { $extra = " $ltxt[3]"; }
	if($settings[1] eq '' && $username ne 'Guest') { &error("$ltxt[4]$extra"); }
}

sub BoardCheck {
	my($bfnd);

	fopen(FILE,"$boards/bdscats.db");
	@catbase = <FILE>;
	fclose(FILE);
	chomp @catbase;

	fopen(FILE,"$boards/bdindex.db");
	@boardbase = <FILE>;
	fclose(FILE);
	chomp @boardbase;

	if($URL{'v'} eq '' || $URL{'b'} eq '') { return; }

	$bfnd = 1;
	foreach (@boardbase) {
		($boardid,$binfo[0],$binfo[1],$binfo[2],$binfo[3],$binfo[4],$binfo[5],$binfo[6],$binfo[7]) = split("/",$_);
		if($URL{'b'} eq $boardid) { $bfnd = 0; last; }
	}
	if($bfnd) { &error($ltxt[5]); }
	@mods = split(/\|/,$binfo[1]);
	foreach (@mods) { if($username eq $_) { $ismod = 1; last; } }

	foreach (@catbase) {
		($nme,$id,$grps,$input) = split(/\|/,$_);
		if($input ne '') { @cats = split("/",$input); } else { next; }
		foreach (@cats) {
			if($_ eq $URL{'b'}) { $catid = $id; $memgrp = $grps; last; }
		}
	}
	if($memgrp ne '') {
		$con = '';
		@mgrps = split(",",$memgrp);
		foreach $grp (@mgrps) { if($grp eq $settings[4]) { $con = 1; } }
		if($con eq '' && $settings[4] ne 'Administrator') { &error($ltxt[5]); }
	}
	if($binfo[6] ne '') { CoreLoad('BoardLock'); &Password; }
	$boardnm = $binfo[2];
}

sub Mods {
	if(@mods == 1) { $modz = "$ltxt[6]: "; }
	elsif(@mods > 1) { $modz = "$ltxt[7]: "; }
		else { $modz = "$ltxt[8]"; }
	foreach (@mods) {
		&loaduser($_);
		$modz .= qq!<a href=$scripturl,v=profile,a=view,u=$_>$userset{$_}->[1]</a>, !;
	}
	$modz =~ s/, \Z//gi;
	if(@mods > 1) { $mds = "s"; }
}

sub loaduser {
	my($user) = $_[0];   # DO NOT ADD LOADUSER TO MY STATEMENT!
	if($userset{$user}->[1]) { return; } # User is already loaded! We don't need more cycles of this routines!
	fopen(LOADUSER,"$members/$user.dat");
	@loaduser = <LOADUSER>;
	fclose(LOADUSER);

	for($i = 0; $i < @loaduser; $i++) {
		chomp $loaduser[$i];
		if($i == 12 && $hiddenmail) { $userset{$user}->[$i] = 1; next; }
		$userset{$user}->[$i] = $loaduser[$i];
	}

	$userset{$user}->[1] = CensorList($userset{$user}->[1]);
}

sub LMG {
	fopen(FILE,"$prefs/Ranks.txt");
	@memgrps = <FILE>;
	fclose(FILE);
	chomp @memgrps;
	$cnt = 0;
	foreach(@memgrps) {
		($grpname,$grpper) = split(/\|/,$_);
		$memgrps[$cnt] = $grpname;
		$memgrpp[$cnt] = $grpper;
		++$cnt;
	}
	&GMS;
	&LMGS;
}

sub loaduserdisplay {
	my($user) = $_[0];
	my($memberstar,$memberpic,$membericq,$memberaim,$membermsn,$memberpost,$ppd,$memberyim);
	if(!$LMG) { &LMG; $LMG = 1; }

	loaduser($user);
	$guest = 0;
	if($userset{$user}->[1] eq '') {
		$membername = $user;
		$memberstat = $gtxt{'0'};
		$mprofile = '';
		$guest = 1;
		return;
	}
	$membername = qq~<a href="$scripturl,v=profile,a=view,u=$user">$userset{$user}->[1]</a>~;

	if($userset{$user}->[3] >= $maxcount) {
		$memberstat = $memgrps[1];
		$memberstar = '5star';
	} elsif($userset{$user}->[3] >= $bigcount) {
		$memberstat = $memgrps[2];
		$memberstar = '4star';
	} elsif($userset{$user}->[3] >= $medcount) {
		$memberstat = $memgrps[3];
		$memberstar = '3star';
	} elsif($userset{$user}->[3] >= $mincount) {
		$memberstat = $memgrps[4];
		$memberstar = '2star';
	} else {
		$memberstat = $memgrps[5];
		$memberstar = '1star';
	}
	if($userset{$user}->[4] ne '') {
		$team = '';
		if($team{$userset{$user}->[4]}) { $team = qq~<img src="$images/team.gif" alt="$gtxt{'29'}"> ~; }
		if($star{$userset{$user}->[4]} || $team) { $memberstat = qq~<b>$userset{$user}->[4]</b>~; }
			else { $memberstat .= "<br><i>$userset{$user}->[4]</i>"; }
		$memberstat = "$team$memberstat";
		if($star{$userset{$user}->[4]}) { $memberstar = $star{$userset{$user}->[4]}; }
	}
	foreach (@mods) {
		if($user eq $_) {
			$memberstat = qq~$team1 <b>$memgrps[6]</b>~;
			$memberstar = 'starmod';
			last;
		}
	}
	if($userset{$user}->[4] eq 'Administrator') {
		$memberstat = qq~<img src="$images/team.gif" alt="$gtxt{'29'}"> <b>$memgrps[0]</b>~;
		$memberstar = 'staradmin';
	}
	$memberstar = qq~<img src="$images/$memberstar.gif">~;
	$memberstat = $memberstat;

	if($userset{$user}->[5] && $apic) {
		$pic = $userset{$user}->[5];
		if($userset{$user}->[5] =~ /\//) { $memberpic = qq~<img src="$pic" width="$picwidth" height="$picheight">~; }
			else { $memberpic = qq~<img src="$avsurl/$userset{$user}->[5]">~; }
	}

	if($userset{$user}->[12] && $hmail) { $memberemail = ''; }
		else { $memberemail = qq~<a href="mailto:$userset{$user}->[2]">$img{'email'}</a> $msp~; }

	$memberpost = "<b>$ltxt[9]:</b> $userset{$user}->[3]<br>";
	if($userset{$user}->[9]) { $memberaim = qq~<a href="aim:goim?screenname=$userset{$user}->[9]&message=You+there?" title="$ltxt[10] ($userset{$user}->[9])"><img src="$images/aim.gif" border="0"></a>~; }
	if($userset{$user}->[10]) { $membermsn = qq~<img src="$images/msn.gif" alt="$userset{$user}->[10]">~; }
	if($userset{$user}->[8]) { $membericq = qq~<a href="http://wwp.icq.com/scripts/search.dll?to=$userset{$user}->[8]" target="icq"><img src="$images/icqadd.gif" alt="$userset{$user}->[8]" border="0"></a>~; }
	if($userset{$user}->[27]) { $memberyim = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$userset{$user}->[27]" target="yim"><img src="$images/yim.gif" alt="$userset{$user}->[27]" border="0"></a>~; }
	if($userset{$user}->[11]) {
		$message = $userset{$user}->[11];
		&BC;
		$message = qq~$message2<hr size="1" color="$color{'border'}"><font size="1">$message</font>~;
	}
	if($showgender) {
		if($userset{$user}->[7] == 1) { $pic = "male"; $gen = $ltxt[11]; }
		elsif($userset{$user}->[7] == 2) { $pic = "female"; $gen = $ltxt[12]; }
		$gender = qq~<b>Gender:</b> <img src="$images/$pic.gif"> <b>$gen</b>~;
		if(!$userset{$user}->[7]) { $gender = ''; }
	}
	if($sppd) {
		($t,$t,$t,$lday,$lmonth,$lyear,$lweek) = localtime($userset{$user}->[14]);
		($t,$t,$t,$cday,$cmonth,$cyear,$cweek) = localtime(time);
		$lyear = substr($lyear,-2);
		$cyear = substr($cyear,-2);
		++$lmonth; ++$cmonth;
		$reg = (365*$lyear)+(30.42*$lmonth)+$lday;
		$now = (365*$cyear)+(30.42*$cmonth)+$cday;
		$days = ($now-$reg) || 1;
		$ppd = sprintf("<b>$ltxt[13]: </b> %.2f", $userset{$user}->[3]/$days);
	}
	$mprofile = qq~$memberstar<br><br> <center>$memberpic<br> $userset{$user}->[6]<br><br>$membericq&nbsp; $memberaim &nbsp;$memberyim &nbsp;$membermsn</center>$gender<br>$memberpost $ppd~;
}

sub LogPage {
	my($lid,$ltime,$found,$lltime);
	if($username eq 'Guest') { return; }
	fopen(ULOG,"$members/$username.log");
	@log = <ULOG>;
	fclose(ULOG);
	chomp @log;

	$lltime = (time+2); # +2 prevents "Your New Post == New".

	fopen(ULOG,"+>$members/$username.log");
	if($URL{'m'} ne '') { print ULOG "$URL{'m'}|$lltime\n"; }
	print ULOG "$URL{'b'}|$lltime\n";
	foreach (@log) {
		($lid,$ltime) = split(/\|/,$_);
		if($lid ne $URL{'m'} && $lid ne $URL{'b'} && $ltime+($logdays*86400) > time) { print ULOG "$_\n"; }
	}
	fclose(ULOG);
}

sub LMGS {
	if($settings[4] eq 'Administrator') { return; }
	for($i = 7; $i < @memgrps; $i++) {
		if($settings[4] eq $memgrps[$i]) {
			($ip,$mod,$st,$m,$pro,$t,$t,$t,$cal,$admin) = split(',',$memgrpp[$i]);
			if($admin) { $settings[4] = 'Administrator'; return; } # User is an admin
			$ipon = $ip; $modon = $mod; $ston = $st;
			$modifyon = $m; $proon = $pro;
			$calmod = $cal;
			last;
		}
	}
}

sub GMS {
	push(@admins,'Administrator');
	for($q = 0; $q < @memgrps; $q++) {
		($t,$t,$t,$t,$t,$star,$team,$t,$t,$admin) = split(',',$memgrpp[$q]);
		$star{$memgrps[$q]} = $star;
		$team{$memgrps[$q]} = $team;
		if($admin) { push(@admins,$memgrps[$q]); }
	}
}

sub Ban {
	fopen(FILE,"$prefs/BanList.txt");
	@banlist = <FILE>;
	fclose(FILE);
	chomp @banlist;
	foreach (@banlist) {
		($ipaddy,$banlimit,$bantime) = split(/\|/,$_);
   		$length = length($ipaddy);
   		$ipsearch = substr($ENV{'REMOTE_ADDR'},0,$length);
		if($ipsearch =~ /\Q$ipaddy/i || $username eq $ipaddy) { require("$code/BoardLock.pl"); &Banned($banlimit,$bantime); }
	}
}

sub FindRanks {
	my(@rdata);
	($frank) = $_[0];
	fopen(FILE,"$members/List.txt");
	@list = <FILE>;
	fclose(FILE);
	chomp @list;
	foreach(@list) {
		loaduser($_);
		if($userset{$_}->[4] eq $frank) { push(@rdata,$_); }
	}
	return(@rdata);
}

sub Format {
	($temp) = $_[0];
	# $temp =~ s/\&/\&amp;/g;
	$temp =~ s/</&lt;/g;
	$temp =~ s/>/&gt;/g;
	$temp =~ s/\cM//g;
	$temp =~ s/\n/<br>/g;
	$temp =~ s/\|/\&#124;/g;
	$temp =~ s/"/\&quot;/g;
	$temp =~ s/  /&nbsp; /gi;
	$temp =~ s/\t/&nbsp; &nbsp;/gi;
	return $temp;
}

sub Unformat {
	($temp) = $_[0];
	$temp =~ s/&lt;/</g;
	$temp =~ s/&gt;/>/g;
	$temp =~ s/<br>/\n/g;
	$temp =~ s/  /&nbsp; /gi;
	return $temp;
}

sub BoardProperties {
	$pwed .= $binfo[6] ? $ltxt[14] : $var{'80'};
	if($memgrp) { $pwed .= " ($var{'81'})"; }
	if($noguestp == 1 && $noguest == 0) { $guesta = " $var{'82'}"; }
	if($binfo[3] == 1) { $sthreads = $var{'83'}; }
	elsif($binfo[3] == 2) { $sthreads = $var{'84'}; }
	elsif($binfo[3] == 3) { $sthreads = $var{'85'}; }
	elsif($binfo[3] == 4) { $sthreads = $var{'84'}; }
		else { $sthreads = "$var{'83'}$guesta"; }
	if($binfo[4] == 1) { $rthreads = $var{'83'}; }
	elsif($binfo[4] == 2) { $rthreads = $var{'84'}; }
	elsif($binfo[4] == 3) { $rthreads = $var{'85'}; }
	elsif($binfo[4] == 4) { $sthreads = $var{'84'}; }
		else { $rthreads = "$var{'83'}$guesta"; }
	$polling = $binfo[5] ? $ltxt[15] : $ltxt[16];
	$attachments = $uallow ? $ltxt[16] : $ltxt[15];
}

sub ListBoards {
	if(!$boardbase[1]) { return("<font size=\"1\">$boardnm ($ltxt[19])</font>"); }
	my($temp,@bdsh,$hh,$bbase,$name,$bid,$bhere,$access);
	$temp = qq~<script language="JavaScript">
<!--
function JumpTo(ghere) {
 if(ghere != '') { location = "$surl,v=mindex,b="+ghere; }
}
//-->
</script>
<select name="JumpZ" onChange="JumpTo(this.value);">
<option value="">-&#187; $boardnm $ltxt[21]</option><option value="">-----------------------</option>~;
	foreach(@catbase) {
		($t,$t,$access,$bhere) = split(/\|/,$_);
		if($access ne $settings[4] && $settings[4] ne 'Administrator') { next; }
		@bdsh = split("/",$bhere);
		foreach $hh (@bdsh) {
			foreach $bbase (@boardbase) {
				($bid,$t,$t,$name) = split("/",$bbase);
				if($bid eq $URL{'b'} || $bid ne $hh) { next; }
				$temp .= qq~<option value="$bid">&nbsp; -&#187; $name</option>~;
				last;
			}
		}
	}
	$temp .= qq~</select>~;
	return($temp);
}

sub FindStatus {
	my($temp);
	if($type) { $temp = 'locked'; }
	elsif($replies > $vhtdmax) { $temp = 'veryhotthread'; }
	elsif($replies > $htdmax) { $temp = 'hotthread'; }
		else { $temp = 'thread'; }
	if($poll && $type) { $temp = 'poll_lock'; }
	elsif($poll) { $temp = 'poll_icon'; }
	if($stickme{$messid} && $type && $temp ne 'poll_icon') { $temp = 'sticky_lock'; }
	elsif($stickme{$messid} && $temp eq 'poll_icon') { $temp = 'poll_sticky'; }
	elsif($stickme{$messid}) { $temp = 'sticky'; }
	return($temp);
}

sub CensorList {
	my($takenin) = $_[0];
	if(!$CensorLoad) {
		fopen(CENSOR,"$prefs/Censor.txt");
		@censor = <CENSOR>;
		fclose(CENSOR);
		chomp @censor;
		$CensorLoad = 1;
	}
	foreach(@censor) {
		($censor,$change) = split(/\|/,$_);
		if($censor eq '' || $change eq '') { next; }
		$takenin =~ s~\b\Q$censor\E\b~$change~gi;
	}
	return($takenin);
}

sub LoadColors {
	for($i = 0; $i < @memgrps; $i++) {
		if($i > 6) { ($t,$t,$t,$t,$t,$t,$t,$memgrpp[$i]) = split(",",$memgrpp[$i]); }
		if($i == 0) { $memgrps[$i] = "Administrator"; }
		$gcolors{$memgrps[$i]} = $memgrpp[$i];
	}
}

sub BoardUsers {
	my(@usersonb,@userson);
	$cnt = 0;
	$gcnt = 0;
	fopen(FILE,"$prefs/Active.txt");
	@userson = <FILE>;
	fclose(FILE);
	chomp @userson;

	&LoadColors;

	foreach(@userson) {
		($luser,$ltime,$hidden,$t,$bview) = split(/\|/,$_);
		loaduser($luser);
		if($userset{$luser}->[1] eq '') { $fndu = $luser; } else { $fndu = $userset{$luser}->[1]; }
		push(@usersonb,"$fndu|$luser|$hidden|$bview");
	}
	foreach(sort {lc($a) cmp lc($b)} @usersonb) {
		($trash,$luser,$hidden,$cbrd) = split(/\|/,$_);
		if($cbrd ne $URL{'b'}) { next; }
		if($userset{$luser}->[1] ne '') {
			if($gcolors{$userset{$luser}->[4]}) { $duser = qq~<font color="$gcolors{$userset{$luser}->[4]}"><b>$userset{$luser}->[1]</b></font>~; }
				else { $duser = $userset{$luser}->[1]; }
			if($hidden && $settings[4] ne 'Administrator') { next; }

			$activeusers .= qq~<a href="$scripturl,v=profile,a=view,u=$luser">$duser</a>, ~;
			++$cnt;
		} else {
			++$gcnt;
		}
	}

	$activeusers =~ s/, \Z//;
	if(!$activeusers) { $activeusers = $ltxt[20]; }
}

sub MakeSmall { # To make long code look like it's suppose to, do this. :)
	if(!$BCLoad) { return; }
	$message =~ s~\[(.[^\]]*?)\Z~~gsi;
	$message =~ s/<a href="(.[^">]*?)\Z//gsi;
	$message =~ s~\[code\](.*?)\Z~&Code~esgi;
	$message =~ s~\[quote by=(.+?) link=(.+?) date=(.+?)\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[quote\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[s\](.*?)\Z~<s>$1</s>~gsi;
	$message =~ s~\[b\](.*?)\Z~<b>$1</b>~gsi;
	$message =~ s~\[i\](.*?)\Z~<i>$1</i>~gsi;
	$message =~ s~\[u\](.*?)\Z~<u>$1</u>~gsi;
	$message =~ s~\[size=([1-9][^\s\n<>]*?)\](.*?)\Z~<font size="$1">$2</font>~gsi;
	$message =~ s~\[pre\](.+?)\Z~<pre>$1</pre>~gsi;
	$message =~ s~\[left\](.+?)\Z~<div align="left">$1</div>~gsi;
	$message =~ s~\[right\](.+?)\Z~<div align="right">$1</div>~gsi;
	$message =~ s~\[center\](.+?)\Z~<center>$1</center>~gsi;
	$message =~ s~\[face=(.+?)\](.+?)\Z~<font face="$1">$2</font>~gsi;
	$message =~ s~\[color=(.+?)\](.+?)\Z~<font color="$1">$2</font>~gsi;
	$message =~ s~\[sub\](.+?)\Z~<sub>$1</sub>~gsi;
	$message =~ s~\[sup\](.+?)\Z~<sup>$1</sup>~gsi;
	$message =~ s~\[img(.+?)\Z~~gsi;
	if($message =~ /\[list(.*?)\](.+?)\Z/) {
		$message =~ s~\[list\](.+?)\Z~<ul>$1</ul>~gsi;
		$message =~ s~\[list=([a-zA-Z|1]+?)\](.+?)\Z~<ol type="$1">$2</ol>~gsi;
		$message =~ s~\[\*\]~<li>~gsi;
	}
}
1;